#include "Breakout_types.h"
#include "Breakout_config.h"
#include "Demo.h"

#define __RGB_MATRIX__
#define __SLIDER_2__

demo_object_t wall[ WALL_SIZE ];
demo_object_t paddle;
demo_ball_t ball;

void getUserInput( )
{
#ifdef  __SLIDER_2__
        demo_movePaddle( &paddle, MOV_MODE_SLIDER_2 );
#endif
}

void systemInit( )
{
    mikrobus_logInit( _LOG_USBUART, 9600 );

#ifdef __RGB_MATRIX__
    mikrobus_gpioInit( _MIKROBUS5, _MIKROBUS_INT_PIN, _GPIO_INPUT );
    mikrobus_gpioInit( _MIKROBUS5, _MIKROBUS_CS_PIN, _GPIO_OUTPUT );
    mikrobus_gpioInit( _MIKROBUS5, _MIKROBUS_RST_PIN, _GPIO_OUTPUT );

    mikrobus_spiInit( _MIKROBUS5, &_MATRIXRGB_SPI_CFG[ 0 ] );
#endif

#ifdef __SLIDER_2__
    mikrobus_gpioInit( _MIKROBUS1, _MIKROBUS_PWM_PIN, _GPIO_OUTPUT );
    mikrobus_gpioInit( _MIKROBUS1, _MIKROBUS_CS_PIN, _GPIO_OUTPUT );
#endif

    Delay_ms( 100 );
}

void applicationInit( )
{
#ifdef __RGB_MATRIX__
    matrixrgb_spiDriverInit( ( T_MATRIXRGB_P )&_MIKROBUS5_GPIO,
                             ( T_MATRIXRGB_P )&_MIKROBUS5_SPI );
    matrixrgb_deviceReset( );

    matrixrgb_deviceInit( _MATRIXRGB_PATTERN_1_MAP_6MM );
    matrixrgb_setPower( 1 );
    Delay_ms( 1000 );

    demo_generateWall( wall );

    ball.x = BALL_DEF_X;
    ball.y = BALL_DEF_Y;

    paddle.x = PAD_DEF_X;
    paddle.y = PAD_DEF_Y;

    demo_reset( &ball, &paddle, wall );
#endif

#ifdef __SLIDER_2__
    slider2_gpioDriverInit( ( T_SLIDER2_P )&_MIKROBUS1_GPIO );
    slider2_enable( _SLIDER2_DEVICE_ENABLE );
    slider2_setReference( _SLIDER2_MAX_VOLTAGE_2_048V );

    ADC_Set_Input_Channel( _ADC_CHANNEL_3 );
    ADC1_Init( );
    
    Delay_100ms( );
#endif
}

void applicationTask( )
{
   while( !demo_collisionCheck( &ball, &paddle, wall ) )
   {
          getUserInput( );
          demo_moveBall( &ball );
   }
}

void main( )
{
    systemInit( );
    applicationInit( );

    while ( 1 )
    {
        applicationTask( );
    }
}